% Fr att berkna elasticiteten av skatten p hushllens inkomster
% Denna fil r frbered fr att ven ta hnsyn till arbetslshet.

%clc
%clear all
%close all

global BB AA

% Ls in data
load data
T = length(ar);

% Vlj ln att anvnda; medel eller median
fvinkomst = fvinkomstmedian;

% Skapa en lnevektor 
brutto = 0.01 : 0.01 : BB;
bruttomatris = fvinkomst*brutto;
B = length(brutto);

% Fr att f fram frdelningen
viktmatris = ones(T,1)*vikt(1:B)';   % Hur vanligt det r med en viss ln
bruttovikt = viktmatris.*bruttomatris;   % Hur vanligt med viss ln, viktat med hur stor lnen r
bruttoviktsum = sum(bruttovikt,2);   % Summan av ovanstende fr varje r, fr att kunna normalisera pdfen
bruttoviktsummatris = bruttoviktsum*ones(1,B);

PDF_lon = bruttovikt./bruttoviktsummatris;

% Fr simuleringen av a-kassa
akers = 0.80;   % Ersttningsgraden fr alla
arblosdel = AA;   % Hur stor del av ret som man r arbetsls

%%

% Skapa matriser att fylla
ap = NaN(T,B);
apa = NaN(T,B);
aps = NaN(T,B);
ga = NaN(T,B);
bfi = NaN(T,B);
ks = NaN(T,B);
ss = NaN(T,B);
js = NaN(T,B);

% Berkna skattekomponenterna
for t = 1 : 1 : T  % Fr varje r
    for b = 1 : 1 : B  % Fr varje lneniv
        [ap(t,b), apa(t,b), aps(t,b), ga(t,b), bfi(t,b), ks(t,b), ss(t,b), js(t,b)] = namn{t}((1-arblosdel)*bruttomatris(t,b)+arblosdel*akers*bruttomatris(t,b), (1-arblosdel)*bruttomatris(t,b), pbb(t), ma(t), ki(t), sg1(t), sg2(t), si(t), sv(t));
    end
end

% Berkna total skatt
ts = max(ap + ks + ss - aps - js, 0);

% Berkna genomsnittligskatt per typfall, i procent
gs = ts ./ bruttomatris * 100;

% Fr att berkna average tax. PDF_lon togs fram tidigare
average_tax = sum(gs.*PDF_lon,2);

%%

% Berkna marginalskatten

% kning av inkomsten: 1/2 prisbasbelopp, pbb
M = pbb/2;

% Berkna skattekomponenterna
m_ap = NaN(T,B);
m_apa = NaN(T,B);
m_aps = NaN(T,B);
m_ga = NaN(T,B);
m_bfi = NaN(T,B);
m_ks = NaN(T,B);
m_ss = NaN(T,B);
m_js = NaN(T,B);

for t = 1 : 1 : T  % Fr varje r
    for b = 1 : 1 : B  % Fr varje lneniv
        [m_ap(t,b), m_apa(t,b), m_aps(t,b), m_ga(t,b), m_bfi(t,b), m_ks(t,b), m_ss(t,b), m_js(t,b)] = namn{t}((1-arblosdel)*bruttomatris(t,b)+M(t)+arblosdel*akers*bruttomatris(t,b), (1-arblosdel)*bruttomatris(t,b)+M(t), pbb(t), ma(t), ki(t), sg1(t), sg2(t), si(t), sv(t));
    end
end

% Berkna total skatt och genomsnittlig skatt (procent)
m_ts = max(m_ap + m_ks + m_ss - m_aps - m_js, 0);


M_matris = M*ones(1,B);

marginalmatris = (m_ts-ts)./M_matris*100;

marginal_tax = sum(marginalmatris.*PDF_lon,2);

%%

% Visa resultatet

resultat=[marginal_tax, average_tax, marginal_tax./average_tax]
%tabell33 = [marginalmatris(:,100), gs(:,100)] %Anvnds endast fr den
%frsta simuleringen

